package com.devsoap.json;

import org.junit.jupiter.api.Test;

import static com.devsoap.json.JsonAssert.assertThat;

public class IntegerAssertionTest {

    private static final String JSON = """
    {
      "positive": 1,
      "negative": -1,
      "zero": 0
    }
    """;

    @Test
    public void equals() {
        assertThat(JSON)
                .field("positive")
                .isEqualTo(1);
        assertThat(JSON)
                .field("negative")
                .isEqualTo(-1);
        assertThat(JSON)
                .field("zero")
                .isEqualTo(0);
    }

    @Test
    public void greaterThan() {
        assertThat(JSON)
                .field("positive")
                .asInteger()
                .isGreaterThan(0);
        assertThat(JSON)
                .field("negative")
                .asInteger()
                .isGreaterThan(-2);
        assertThat(JSON)
                .field("zero")
                .asInteger()
                .isGreaterThan(-1);
    }

    @Test
    public void lessThan() {
        assertThat(JSON)
                .field("positive")
                .asInteger()
                .isLessThan(2);
        assertThat(JSON)
                .field("negative")
                .asInteger()
                .isLessThan(0);
        assertThat(JSON)
                .field("zero")
                .asInteger()
                .isLessThan(1);
    }
}