package com.devsoap.json;

import org.junit.jupiter.api.Test;

import static com.devsoap.json.JsonAssert.assertThat;

public class LongAssertionTest {

    private static final String JSON = """
    {
      "positive": 100000000012,
      "negative": -100000000032,
      "zero": 0
    }
    """;

    @Test
    public void equals() {
        assertThat(JSON)
                .field("positive")
                .asLong()
                .isEqualTo(100000000012L);
        assertThat(JSON)
                .field("negative")
                .asLong()
                .isEqualTo(-100000000032L);
        assertThat(JSON)
                .field("zero")
                .asLong()
                .isEqualTo(0L);
    }

    @Test
    public void greaterThan() {
        assertThat(JSON)
                .field("positive")
                .asLong()
                .isGreaterThan(10000);
        assertThat(JSON)
                .field("negative")
                .asLong()
                .isGreaterThan(-100000000052L);
        assertThat(JSON)
                .field("zero")
                .asLong()
                .isGreaterThan(-1);
    }

    @Test
    public void lessThan() {
        assertThat(JSON)
                .field("positive")
                .asLong()
                .isLessThan(2100000000012L);
        assertThat(JSON)
                .field("negative")
                .asLong()
                .isLessThan(0);
        assertThat(JSON)
                .field("zero")
                .asLong()
                .isLessThan(1);
    }
}